%%%% c3.m
clear all, clc, close all
global tol maxiter
tol = 1e-5;
maxiter = 30;
scrsz = get(groot,'ScreenSize');
%%%
set(0,'defaultaxesfontsize',12,'defaultaxeslinewidth',1.6,...
   'defaultlinelinewidth',1.6,'defaultpatchlinewidth',.7)
%%    figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
format shortg

% %%% funciones anonimas
%  f4 = @(x) x.^4+5;
%  u = [2, 4];
%  z = f4(u);
% % % la funcion anonima admite uso de parametros (funciones inline no lo
% % % permiten)
%  c = 32;
%  zz = c*f4([1 -4])
% % % %
% % % % plot
% 
%     figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  x = 0:.01:1;
%  plot(x,f4(x),'r--')
%  grid on
%  title 'primera funcion anonima'
% 
% % % % %
%  x = linspace(-pi/2,pi/2,40);
%  y = x;
%  [X,Y] = meshgrid(x,y);
%  f = sin(X.^2-Y.^2);
% figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  contour(X,Y,f)
%  figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  contourf(X,Y,f,20)
%  figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  surf(X,Y,f)
% % %
% figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  x = 0:pi/20:pi;
%  n = length(x);
%  r = 1:n/7:n;
%  y = x.^2+3;
%  plot(x,y,'k',x(r),y(r),'r*')
% axis([-pi/3 pi+pi/3 -1 15])
%  xlabel('Valores x')
%  ylabel('Valores y')
%  grid on
%  title('Curva','FontSize',18)
%  text(pi/10,0,'\alpha=\beta^2')
% % % %
%  figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  xx = -pi:pi/30:pi;
%  plot(xx,sin(xx),'rd')
%  hold on
%  plot(xx,cos(xx),'g+')
%  legend('sin', 'cos','Location','best')
%  title('Funciones sin y cos')
%  grid on
%  axis([-pi pi -1 1])
% % %%%%
% %%%% polinomios son vectores fila (coeficientes en orden descendente)
%  q = [1 -1 -6];
%  c = 4:2:8;
% % %%% evaluacion de un polinomio con polyval
%  b = polyval(q,c)
% % % % ceros o raices de un polinomio
%  z = roots(q)
% % % el unico polinomio que pasa por (-2,0), (3,0) y (1,-6) es q
% % % por 3 puntos pasa una unica parabola
% % % encontrar tal polinomio se denomina interpolacion de los datos de una
% % % % tabla
% % % % errores relativo y absoluto
% % % % ve: valor exacto
% % % % vc: valor calculado
% % % % error absoluto = abs(ve-vc)
% % % % error relativo = abs(ve-vc)/abs(ve) y tambien se usa que el denominador
% % % % sea abs(vc)
% % % % si se trata de vectores o matrices, en lugar de abs se usa norm
% % % % si abs(ve) < 1 el error relativo es mayor que el error absoluto
% b = 3;
% bc = 3.01;
% ea = abs(b-bc) 
% er = abs(b-bc)/abs(b)
% d = 0.4;
% dc = 0.38;
% ea = abs(d-dc) 
% er = abs(d-dc)/abs(d)
% 
% figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  g = @(x) 6.^-x;
% z = linspace(-1,1);
% plot(z,g(z),'r',z,z,'k--')
% grid on
% %%% punto fijo
%  [p, k, err, P] = fixpt (g, .48, tol, maxiter)
% %%% biseccion
% g5 = @(x) g(x)-x;
%  %%% biseccion
% [c5, err5, yc5] = bisect (g5, 0.1, 2, tol)
%  
% g1 = @(x) x.^2-3;
% [c, err, yc] = bisect (g1, -1, 2, tol)
%  f = @(x) 2./x;
%  z = linspace(1.3,1.5);
%     figure('Position',[scrsz(3)*2/3 scrsz(4)/2 scrsz(4)/2 scrsz(4)/3])
%  plot(z,f(z),'r',z,z,'k--'),grid on
%   [p, k, err, P] = fixpt (f, 1.4, tol, maxiter)
% f1 = @(x) x.^2-2;
% [c, err, yc] = bisect (f1, 1, 2, tol)
% 
% %%%%%%%%%
%%%% metodo de Newton para aproximar sqrt(3)
% xold = 2; xnew = 1;
% while abs(xnew-xold) > tol
%     xold = xnew
%     xnew = xnew/2 + 3/(2*xnew)
% end
% 
% f =@(x) x - 2.^(-x);
% fp = @(x) 1 + log(2)*2.^(-x);
% %%%% biseccion
% [c, err, yc] = bisect (f, 0, 1, tol);
% %%%% Newton
% [p0, err, k, y] = newton (f, fp, .5, tol, tol, maxiter);
% %%%
%    g1 = @(x) 9*x.^4+18*x.^3+38*x.^2-57*x+14;
%    g1p = @(x) 36*x.^3+54*x.^2+76*x-57;
% [p0, err, k, y] = newton (g1, g1p, .5, tol, tol, maxiter);
% %%%
%   g2 = @(x) 6*exp(x)-2*x.^3-3*x.^2-6*x-6;
%   g2p = @(x) 6*exp(x)-6*x.^2-6*x-6;
% [p0, err, k, y] = newton (g2, g2p, .5, tol, tol, maxiter)
% %%%
%   g0 = @(x) x.^2-3;
%   g0p = @(x) 2*x;
% [p0, err, k, y] = newton (g0, g0p, .5, tol, tol, maxiter)
% % %%%
%  s = @(x) x.*exp(x)-exp(x)+1;
%  ds = @(x) x.*exp(x);
% [p0, err, k, y] = newton (s, ds, .5, tol, tol, maxiter)
% %%%
% 
%   s1 = @(x) 2*x.*(1-x.*x+x).*log(x)-x.*x+1;
%   ds1 = @(x) -2*x+2*(x.*log(x)).*(-2*x+1)+2*(1+log(x)).*(1-x.*x+x);
% [p0, err, k, y] = newton (s1, ds1, .5, tol, tol, maxiter)
% 
% %%%[p0, err, k, y] = newton (f, df, p0, delta, epsilon, max1)
